#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988

uint16_t tetris[] = {
  NOTE_E4, NOTE_E1, NOTE_E4, NOTE_E2, NOTE_B3, NOTE_E1, NOTE_C4, NOTE_E2,
  NOTE_D4, NOTE_E1, NOTE_D4, NOTE_E2, NOTE_C4, NOTE_E1, NOTE_B3, NOTE_D2,
  NOTE_A3, NOTE_A1, NOTE_A3, NOTE_A2, NOTE_A3, NOTE_A1, NOTE_C4, NOTE_A2,
  NOTE_E4, NOTE_A1, NOTE_E4, NOTE_A2, NOTE_D4, NOTE_A1, NOTE_C4, NOTE_A2,
  NOTE_B3, NOTE_GS1, NOTE_B3, NOTE_GS2, NOTE_B3, NOTE_GS1, NOTE_C4, NOTE_GS2,
  NOTE_D4, NOTE_E1, NOTE_D4, NOTE_E2, NOTE_E4, NOTE_E1, NOTE_E4, NOTE_E2,
  NOTE_C4, NOTE_A1, NOTE_C4, NOTE_A1, NOTE_A3, NOTE_A1, NOTE_A3, NOTE_A2,
  NOTE_A3, NOTE_A1, NOTE_A3, NOTE_A2, NOTE_A3, NOTE_B1, NOTE_A3, NOTE_C2,
  NOTE_D4, NOTE_D1, NOTE_D4, NOTE_D2, NOTE_D4, NOTE_D1, NOTE_F4, NOTE_D2,
  NOTE_A4, NOTE_D1, NOTE_A4, NOTE_D2, NOTE_G4, NOTE_D1, NOTE_F4, NOTE_D2,
  NOTE_E4, NOTE_C1, NOTE_E4, NOTE_C2, NOTE_E4, NOTE_C1, NOTE_C4, NOTE_C2,
  NOTE_E4, NOTE_C1, NOTE_E4, NOTE_C2, NOTE_D4, NOTE_C1, NOTE_C4, NOTE_C2,
  NOTE_B3, NOTE_GS1, NOTE_B3, NOTE_GS2, NOTE_B3, NOTE_GS1, NOTE_C4, NOTE_GS2,
  NOTE_D4, NOTE_E1, NOTE_D4, NOTE_E2, NOTE_E4, NOTE_E1, NOTE_E4, NOTE_E2,
  NOTE_C4, NOTE_A1, NOTE_C4, NOTE_A2, NOTE_A3, NOTE_A1, NOTE_A3, NOTE_A2,
  NOTE_A3, NOTE_A1, NOTE_A3, NOTE_A2, NOTE_A3, NOTE_A1, NOTE_A3, NOTE_G1
};

uint16_t sfx[8][8]={
    {NOTE_C4, 0, 0, 0, 0, 0, 0, 0},
    {NOTE_C4, NOTE_E4, NOTE_G4, NOTE_C5, 1, 1, 1, 1},
    {NOTE_C2, NOTE_G2, 1, 1, 1, 1, 1, 1},
    {NOTE_C3, 0, 0, 0, 0, 0, 0, 0},
    {NOTE_C4, 0, 0, 0, 0, 0, 0, 0},
    {NOTE_C3, NOTE_B2, NOTE_A2, NOTE_G2, NOTE_F2, NOTE_E2, 1, 1},
    {NOTE_C4, NOTE_G4, NOTE_E4, NOTE_C4, NOTE_G3, NOTE_E3, NOTE_C3, 1},
    {NOTE_B5, 0, 0, 0, 0, 0, 0, 0}
};

uint16_t melody_c;
uint16_t sfxn, sfxc;
uint16_t period;
uint8_t no_sfx, no_music;

void melody_cb()
{
  if ((melody_c % 2)==1) {
    if (sfxn != 0) {
      period=50000/sfx[sfxn][sfxc];
      sfxc++;
      if (sfxc>7 || period>10000) sfxn=0;
      //analogWrite(4,300); 
    } else { period=10; } //analogWrite(4,0); }
  } else { period=tetris[melody_c/2]; }//analogWrite(4,300); }

  analogWriteFreq(period*1.5);

  if (++melody_c>255) melody_c=0;
}
